/**   
* @Title: WorksController.java 
* @Package com.hdp.customerservice.api.admin 
* @Description: TODO
* @author new12304508_163_com   
* @date 2015年6月17日 下午5:01:31 
* @version V1.0   
*/
package com.hdp.customerservice.api.admin;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.hdp.customerservice.dto.DTO;
import com.hdp.customerservice.model.WorksEntity;
import com.hdp.customerservice.service.WorksService;

@Controller
@RequestMapping("/admin/customerservice/worker")
public class WorksController {

	@Autowired
	private WorksService worksService;
	Integer entCode = 10001;
	
	@RequestMapping(value = "", method = RequestMethod.POST)
	@ResponseBody
	public String save(@RequestBody WorksEntity entity){
		DTO dto = DTO.newDTO();
		entity.setEntCode(entCode);
		dto.data=worksService.save(entity);
		return dto.toJson();
	}
	
	@RequestMapping(value = "/pageList", method = RequestMethod.GET)
	@ResponseBody
	public String pageList(@RequestParam(value = "pageNo", defaultValue = "1", required = false) Integer page,
			@RequestParam(value = "pageSize", defaultValue = "10", required = false) Integer size){
		DTO dto = DTO.newDTO();
		dto.data=worksService.findPage(page, size);
		return dto.toJson();
	}
	
	@RequestMapping(value = "/{id}", method = RequestMethod.GET)
	@ResponseBody
	public String getWorkById(@PathVariable Long id){
		DTO dto = DTO.newDTO();
		dto.data=worksService.get(id);
		return dto.toJson();
	}
	
	@RequestMapping(value = "/{id}/status", method = RequestMethod.PUT)
	@ResponseBody
	public String updateStatus(@PathVariable Long id,Integer status){
		DTO dto = DTO.newDTO();
		dto.data=worksService.get(id);
		return dto.toJson();
	}
}
