/**   
* @Title: AbstractBaseServiceImpl.java 
* @Package com.hdp.customerservice.service 
* @Description: TODO
* @author new12304508_163_com   
* @date 2015年6月17日 下午2:07:07 
* @version V1.0   
*/
package com.hdp.customerservice.service;

import java.io.Serializable;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort;
import org.springframework.data.jpa.domain.Specification;

import com.hdp.customerservice.repository.BaseRepository;

public abstract class AbstractBaseServiceImpl<E, PK extends Serializable> implements BaseService<E, PK> {

	@Autowired
	protected BaseRepository<E, PK> repository;
	
	@Override
	public E get(PK id) {
		return repository.findOne(id);
	}

	@Override
	public List<E> getAllList() {
		return repository.findAll();
	}

	@Override
	public Long getTotalCount() {
		return repository.count();
	}

	@Override
	public E save(E entity) {
		return repository.save(entity);
	}

	@Override
	public E update(E entity) {
		return repository.save(entity);
	}

	@Override
	public E saveOrUpdate(E entity) {
		return repository.save(entity);
	}

	@Override
	public boolean existById(PK id) {
		return repository.exists(id);
	}

	@Override
	public void delete(PK id) {
		repository.delete(id);
	}

	@Override
	public void deleteByIds(List<PK> ids) {
		repository.delete(repository.findAll(ids));
	}

	@Override
	public Page<E> findPage(int page, int size) {
		return findPage(page, size, null, null);
	}
	
	@Override
	public Page<E> findPage(int page, int size,Sort sort) {
		return findPage(page, size, sort);
	}
	
	@Override
	public Page<E> findPage(int page, int size,Specification<E> spec) {
		return findPage(page, size, spec);
	}
	
	@Override
	public Page<E> findPage(int page, int size,Sort sort,Specification<E> spec) {
		PageRequest pageRequest = null;
		if(sort != null){
			pageRequest = new PageRequest(page-1, size, sort);
		}else{
			pageRequest = new PageRequest(page-1, size);
		}
		
		if(spec != null){
			return repository.findAll(spec, pageRequest);
		}
		return repository.findAll(pageRequest);
	}

}

